//
// php-armadillo/dense_matrix.hh
//
// @Author CismonX
//

#ifndef PHP_ARMA_DENSE_MATRIX_HH
#define PHP_ARMA_DENSE_MATRIX_HH

#include "common/php_arma.hh"

namespace php_arma
{
    template <typename T, typename ChildT>
    struct dense_matrix
    {
        using native_t = typename ChildT::native_t;

        PHP_ARMA_COMMON_DECLARE();

    private:
        static PHP_FUNCTION(__invoke);
        static PHP_FUNCTION(at);
        static PHP_FUNCTION(col);
        static PHP_FUNCTION(row);
        static PHP_FUNCTION(cols);
        static PHP_FUNCTION(rows);
        static PHP_FUNCTION(submat);
        static PHP_FUNCTION(diag);
        static PHP_FUNCTION(eachRow);
        static PHP_FUNCTION(eachCol);
        static PHP_FUNCTION(i);
        static PHP_FUNCTION(isSympd);

    };

    void dense_matrix_init();

    constexpr const char dense_matrix_php_name[] = "DenseMatrix";

    inline zend_class_entry *dense_matrix_ce;
}

#endif // !PHP_ARMA_DENSE_MATRIX_HH
