//
// php-armadillo/dense_non_resizable_matrix.cc
//
// @Author CismonX
//

#include "dense_non_resizable_matrix.hh"
#include "non_resizable_matrix.hh"
#include "dense_matrix.hh"
#include "subview_mat.hh"

namespace php_arma
{
    template <typename T, typename T1>
    PHP_ARMA_METHOD(dense_non_resizable_matrix, ones, T, T1)
    {
        auto native = THIS_NATIVE;
        native->ones();
        RETVAL_THIS();
    }

    template <typename T, typename T1>
    PHP_ARMA_METHOD(dense_non_resizable_matrix, randu, T, T1)
    {
        auto native = THIS_NATIVE;
        native->randu();
        RETVAL_THIS();
    }

    template <typename T, typename T1>
    PHP_ARMA_METHOD(dense_non_resizable_matrix, randn, T, T1)
    {
        auto native = THIS_NATIVE;
        native->randn();
        RETVAL_THIS();
    }

    template <typename T, typename T1>
    PHP_ARMA_START_ME(dense_non_resizable_matrix, T, T1)
        PHP_ARMA_ME(ones,  ZEND_ACC_PUBLIC)
        PHP_ARMA_ME(randu, ZEND_ACC_PUBLIC)
        PHP_ARMA_ME(randn, ZEND_ACC_PUBLIC)
    PHP_ARMA_END_ME();

    void dense_non_resizable_matrix_init()
    {
        dense_non_resizable_matrix_ce = interface_register<dense_non_resizable_matrix_php_name>(
            non_resizable_matrix_ce, dense_matrix_ce);
    }

    PHP_ARMA_INSTANTIATE(dense_non_resizable_matrix, subview_mat);
}
