//
// php-armadillo/dense_non_resizable_matrix.hh
//
// @Author CismonX
//

#ifndef PHP_ARMA_DENSE_NON_RESIZABLE_MATRIX_HH
#define PHP_ARMA_DENSE_NON_RESIZABLE_MATRIX_HH

#include "common/php_arma.hh"

namespace php_arma
{
    template <typename T, typename ChildT>
    struct dense_non_resizable_matrix
    {
        using native_t = typename ChildT::native_t;

        PHP_ARMA_COMMON_DECLARE();

    private:
        static PHP_FUNCTION(ones);
        static PHP_FUNCTION(randu);
        static PHP_FUNCTION(randn);
    };

    void dense_non_resizable_matrix_init();

    constexpr const char dense_non_resizable_matrix_php_name[] = "DenseNonResizableMatrix";

    inline zend_class_entry *dense_non_resizable_matrix_ce;
}

#endif // !PHP_ARMA_DENSE_NON_RESIZABLE_MATRIX_HH
