//
// php-armadillo/dense_resizable_matrix.hh
//
// @Author CismonX
//

#ifndef PHP_ARMA_DENSE_RESIZABLE_MATRIX_HH
#define PHP_ARMA_DENSE_RESIZABLE_MATRIX_HH

#include "common/php_arma.hh"

namespace php_arma
{
    template <typename T, typename ChildT>
    struct dense_resizable_matrix
    {
        using native_t = typename ChildT::native_t;

        PHP_ARMA_COMMON_DECLARE();

    private:
        static PHP_FUNCTION(init);
        static PHP_FUNCTION(ones);
        static PHP_FUNCTION(randu);
        static PHP_FUNCTION(randn);
        static PHP_FUNCTION(insertRows);
        static PHP_FUNCTION(insertCols);
        static PHP_FUNCTION(swap);
        static PHP_FUNCTION(isSorted);
        static PHP_FUNCTION(headCols);
        static PHP_FUNCTION(headRows);
        static PHP_FUNCTION(tailCols);
        static PHP_FUNCTION(tailRows);
    };

    void dense_resizable_matrix_init();

    constexpr const char dense_resizable_matrix_php_name[] = "DenseResizableMatrix";

    inline zend_class_entry *dense_resizable_matrix_ce;
}

#endif // !PHP_ARMA_DENSE_RESIZABLE_MATRIX_HH
