//
// php-armadillo/matrix.hh
//
// @Author CismonX
//

#ifndef PHP_ARMA_MATRIX_HH
#define PHP_ARMA_MATRIX_HH

#include "common/php_arma.hh"

namespace php_arma
{
    template <typename T, typename ChildT>
    struct matrix
    {
        using native_t = typename ChildT::native_t;
    
        PHP_ARMA_COMMON_DECLARE();

    private:
        static PHP_FUNCTION(nRows);
        static PHP_FUNCTION(nCols);
        static PHP_FUNCTION(isVec);
        static PHP_FUNCTION(isCol);
        static PHP_FUNCTION(isRow);
        static PHP_FUNCTION(isSquare);
        static PHP_FUNCTION(isSymmetric);
        static PHP_FUNCTION(isHermitian);
        static PHP_FUNCTION(swapRows);
        static PHP_FUNCTION(swapCols);
        static PHP_FUNCTION(t);
    };

    void matrix_init();

    constexpr const char matrix_php_name[] = "Matrix";

    inline zend_class_entry *matrix_ce;
}

#endif // !PHP_ARMA_MATRIX_HH
