//
// php-armadillo/resizable.hh
//
// @Author CismonX
//

#ifndef PHP_ARMA_RESIZABLE_HH
#define PHP_ARMA_RESIZABLE_HH

#include "common/php_arma.hh"

namespace php_arma
{
    template <typename T, typename ChildT>
    struct resizable
    {
        using native_t = typename ChildT::native_t;

        PHP_ARMA_COMMON_DECLARE();

    private:
        static PHP_FUNCTION(copySize);
        static PHP_FUNCTION(reset);
        static PHP_FUNCTION(setReal);
        static PHP_FUNCTION(setImag);
        static PHP_FUNCTION(save);
        static PHP_FUNCTION(load);
    };

    void resizable_init();

    constexpr const char resizable_php_name[] = "Resizable";

    inline zend_class_entry *resizable_ce;
}

#endif // !PHP_ARMA_RESIZABLE_HH
