//
// php-armadillo/resizable_matrix.hh
//
// @Author CismonX
//

#ifndef PHP_ARMA_RESIZABLE_MATRIX_HH
#define PHP_ARMA_RESIZABLE_MATRIX_HH

#include "common/php_arma.hh"

namespace php_arma
{
    template <typename T, typename ChildT>
    struct resizable_matrix
    {
        using native_t = typename ChildT::native_t;

        PHP_ARMA_COMMON_DECLARE();

    private:
        static PHP_FUNCTION(fromString);
        static PHP_FUNCTION(fromArray);
        static PHP_FUNCTION(reshape);
        static PHP_FUNCTION(resize);
        static PHP_FUNCTION(setSize);
        static PHP_FUNCTION(zeros);
        static PHP_FUNCTION(eye);
        static PHP_FUNCTION(inRange);
        static PHP_FUNCTION(shedRow);
        static PHP_FUNCTION(shedCol);
        static PHP_FUNCTION(shedRows);
        static PHP_FUNCTION(shedCols);

    };

    void resizable_matrix_init();

    constexpr const char resizable_matrix_php_name[] = "ResizableMatrix";

    inline zend_class_entry *resizable_matrix_ce;
}

#endif // !PHP_ARMA_RESIZABLE_MATRIX_HH
