//
// php-armadillo/subview.cc
//
// @Author CismonX
//

#include "subview.hh"
#include "mapval.hh"
#include "subview_mat.hh"
#include "diagonal.hh"

namespace php_arma
{
    template <typename T, typename T1>
    PHP_ARMA_METHOD(subview, getParent, T, T1)
    {
        auto current = Z_OBJ(EX(This));
        ZVAL_COPY(return_value, OBJ_PROP_NUM(current, 0));
    }

    template <typename T, typename T1>
    PHP_ARMA_START_ME(subview, T, T1)
        PHP_ARMA_ME(getParent, ZEND_ACC_PUBLIC)
    PHP_ARMA_END_ME();

    void subview_init()
    {
        subview_ce = interface_register<subview_php_name>();
    }

    PHP_ARMA_INSTANTIATE(subview, mapval_dense);
    PHP_ARMA_INSTANTIATE(subview, mapval_spmat);
    PHP_ARMA_INSTANTIATE(subview, mapval_sp_subview);
    PHP_ARMA_INSTANTIATE(subview, subview_mat);
    PHP_ARMA_INSTANTIATE(subview, diagview);
}
