<?php

namespace Arma;

/**
 * Column vector.
 *
 * @package Arma
 */
abstract class Col implements Internal\DenseResizableVector
{
    /**
     * At the given row index, insert given number of empty rows and optionally specify
     * whether to initialize new elements to zero, or insert a copy of specified object
     * (whose column size is the same as the recipient object),
     *
     * @param int                $row_idx
     * @param Internal\Dense|int $rows
     * @param bool               $set_to_zero[optional]
     * @return void
     */
    function insertRows($row_idx, $rows, $set_to_zero = true) {}

    /**
     * Remove the specified range of rows from the column vector.
     *
     * @param int $first_row
     * @param int $last_row
     * @return void
     */
    function shedRows($first_row, $last_row) {}

    /**
     * Swap the contents of specified rows.
     *
     * @param int $row_1
     * @param int $row_2
     * @return void
     */
    function swapRows($row_1, $row_2) {}
}

class_alias(Col::class, 'Arma\\Vec');
