<?php

namespace Arma;

/**
 * Options when saving/loading data in HDF5 format.
 *
 * @package Arma
 */
abstract class Hdf5Opts
{
    /**
     * No extra options.
     */
    const NONE = 0;

    /**
     * Save/load the data with columns transposed to rows (and vice versa).
     */
    const TRANS = 1 << 0;

    /**
     * Instead of overwriting the file, append the specified dataset to the file.
     *
     * The specified dataset must not already exist in the file
     */
    const APPEND = 1 << 1;

    /**
     * Instead of overwriting the file, replace the specified dataset in the file.
     */
    const REPLACE = 1 << 2;
}
