<?php

namespace Arma;

/**
 * Constants for specifying sorting directions of elements.
 *
 * @package Arma
 */
abstract class SortDirection
{
    /**
     * Elements are ascending, consecutive elements can be equal.
     */
    const ASCEND = 0;

    /**
     * Elements are descending, consecutive elements can be equal.
     */
    const DESCEND = 1;

    /**
     * Elements are strictly ascending, consecutive elements cannot be equal.
     */
    const STRICT_ASCEND = 2;

    /**
     * Elements are strictly descending, consecutive elements cannot be equal.
     */
    const STRICT_DESCEND = 3;
}
