<?php

namespace Arma;

/**
 * Sparse matrix which contains a single column.
 *
 * @package Arma
 */
abstract class SpCol implements Internal\SparseResizableVector
{
    /**
     * Remove the specified range of rows from the column vector.
     *
     * @param int $first_row
     * @param int $last_row
     * @return void
     */
    function shedRows($first_row, $last_row) {}

    /**
     * Swap the contents of specified rows.
     *
     * @param int $row_1
     * @param int $row_2
     * @return void
     */
    function swapRows($row_1, $row_2) {}
}
