<?php

namespace Arma;

/**
 * Sparse matrix which contains a single row.
 *
 * @package Arma
 */
abstract class SpRow implements Internal\SparseResizableVector
{
    /**
     * Remove the specified range of columns from the row vector.
     *
     * @param int $first_col
     * @param int $last_col
     * @return void
     */
    function shedCols($first_col, $last_col) {}

    /**
     * Swap the contents of specified columns.
     *
     * @param int $col_1
     * @param int $col_2
     * @return void
     */
    function swapCols($col_1, $col_2) {}
}
