<?php

namespace Arma\Internal;

use Arma\Complex;

/**
 * Interface for objects which wraps a single scalar value.
 *
 * @package Arma\Internal
 */
interface Scalar
{
    /**
     * Return a copy of the representing scalar value of this object.
     *
     * @return number|Complex
     */
    function val();

    /**
     * Set the representing value to the specified new value.
     *
     * @param number|Complex $value
     * @return void
     */
    function setTo($value);
}
