<?php

namespace Arma\Internal;

use Arma\SpMapVal;

/**
 * Interface for resizable (non-subview) sparse matrices.
 *
 * @package Arma\Internal
 */
interface SparseResizableMatrix extends SparseMatrix, ResizableMatrix
{
    // Initialization

    /**
     * Construct the matrix to have user specified dimensions and fill with specified pattern.
     * 
     * $density should be specified when filling the matrix with random values.
     *
     * @param int $n_rows[optional]
     * @param int $n_cols[optional]
     * @param int $fill[optional]
     * @param double $density[optional]
     * @return static
     */
    static function init($n_rows, $n_cols, $fill, $density);

    // Subview

    /**
     * {@inheritdoc}
     *
     * @param int $i
     * @param int $j[optional]
     * @return SpMapVal
     */
    function __invoke($i, $j);

    /**
     * {@inheritdoc}
     *
     * @param int $i
     * @param int $j[optional]
     * @return SpMapVal
     */
    function at($i, $j);
}
