--TEST--
Test for constants.
--SKIPIF--
<?php
require_once 'includes/loaded.php';
is_php_arma_loaded();
?>
--FILE--
<?php

require_once 'includes/assert.php';

use Arma\ {
    Fill, FileType, SortDirection, Hdf5Opts
};

$fill = [Fill::NONE, Fill::ZEROS, Fill::ONES, Fill::EYE,  Fill::RANDU, Fill::RANDN];
$file_type = [
    FileType::AUTO_DETECT, FileType::ARMA_BINARY, FileType::ARMA_ASCII,
    FileType::RAW_BINARY,  FileType::RAW_ASCII,   FileType::CSV_ASCII,
    FileType::COORD_ASCII, FileType::PGM_BINARY,  FileType::HDF5_BINARY
];
$sort_direction = [
    SortDirection::ASCEND,        SortDirection::DESCEND,
    SortDirection::STRICT_ASCEND, SortDirection::STRICT_DESCEND
];
$hdf5_opts = [Hdf5Opts::TRANS >> 0, Hdf5Opts::APPEND >> 1, Hdf5Opts::REPLACE >> 2];

batch_assert('constants',
    [range(0, 5),         $fill],
    [range(0, 8),         $file_type],
    [range(0, 3),         $sort_direction],
    [array_fill(0, 3, 1), $hdf5_opts]
);

?>
--EXPECT--
